use Test::More qw( no_plan );

use Sub::Scheduler;
use Time::HiRes qw( sleep time );
use List::MoreUtils qw( all );

my @check;
my $N = 5000;

my $t0 = time;
for my $i (0 .. $N-1) {
    add_task(sub { $check[$i]++ }, $t0+1);
}
my $t_add = time - $t0;

$t0 = time;
run_tasks();
$t_empty_run = time - $t0;

$t0 = time;
my $next = get_next_run_time();
$t_get_next = time - $t0;

sleep $next - time;

$t0 = time;
run_tasks();
$t_run = time - $t0;

is(@check, $N, '@check size correct');
my $all_set = all { $_ == 1 } @check;
ok($all_set, 'all elements in @check equal to 1');

diag(
    sprintf 'add=%.4f empty_run=%.4f get_next=%.4f run=%.4f',
        $t_add,
        $t_empty_run,
        $t_get_next,
        $t_run,
);

